import { HttpPipe } from 'funkster-http';
export declare type JsonParser = <T>(handler: (deserializedBody: T) => HttpPipe, deserialize?: (json: string) => T) => HttpPipe;
export declare type JsonSender = <T>(obj: T, handler?: (json: string) => HttpPipe, serialize?: (obj: T) => string) => HttpPipe;
export declare type JsonTransform<Source, Target> = (source: Source) => Promise<Target>;
export declare function sendJsonWith<T>(obj: T, handler: (json: string) => HttpPipe, toJson: (obj: T) => string): HttpPipe;
export declare function sendJson<T>(obj: T): HttpPipe;
export declare function parseJsonWith<T>(handler: (deserializedBody: T) => HttpPipe, fromJson: (json: string) => T): HttpPipe;
export declare function parseJson<T>(handler: (deserializedBody: T) => HttpPipe): HttpPipe;
export declare function mapJsonWith<Source, Target>(map: JsonTransform<Source, Target>, jsonParse: JsonParser, jsonSend: JsonSender): HttpPipe;
export declare function mapJson<Source, Target>(handler: JsonTransform<Source, Target>): HttpPipe;
